<?xml version="1.0" encoding="utf-8"?>
<!-- ends-with.xsl -->
<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  
  <xsl:output method="text" indent="no"/>

  <xsl:template match="/">
    <xsl:apply-templates select="wordlist" mode="unsorted"/>
    <xsl:apply-templates select="wordlist" mode="default"/>
    <xsl:apply-templates select="wordlist" mode="Spanish"/>
  </xsl:template>

  <xsl:template match="wordlist" mode="unsorted">
    <xsl:text>Word list - unsorted: &#xA;</xsl:text>
    <xsl:for-each select="word">
      <xsl:value-of select="."/>
      <xsl:text>&#xA;</xsl:text>
    </xsl:for-each>
    <xsl:text>&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="wordlist" mode="default">
    <xsl:text>Word list - sorted with default rules:&#xA;</xsl:text>
    <xsl:for-each select="word">
      <xsl:sort select="."/>
      <xsl:value-of select="."/>
      <xsl:text>&#xA;</xsl:text>
    </xsl:for-each>
    <xsl:text>&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="wordlist" mode="Spanish">
    <xsl:text>Word list - sorted with Spanish rules:&#xA;</xsl:text>
    <xsl:for-each select="word">
      <xsl:sort select="." collation="http://saxon.sf.net/collation?class=com.oreilly.xslt.SpanishCollation;"/>
      <xsl:value-of select="."/>
      <xsl:text>&#xA;</xsl:text>
    </xsl:for-each>
    <xsl:text>&#xA;</xsl:text>
  </xsl:template>
</xsl:stylesheet>
