<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:saxon="java:com.oreilly.xslt.HiddenWord"
  xmlns:xalan="xalan://com.oreilly.xslt.HiddenWord"
  xmlns:dotnet="http://www.oreilly.com/xslt"
  extension-element-prefixes="saxon xalan dotnet">

  <xsl:output method="html"/>

  <xsl:template match="/">
    <html>
      <head>
        <title>
          Test of hidden word generator
        </title>
      </head>
      <body style="font-family: sans-serif;">
	      <h1>Test of hidden word generator</h1>
        <xsl:comment>
          This &lt;form&gt; doesn't have a method or action
          attribute; a real form would, of course...
        </xsl:comment>
        <xsl:variable name="error">
	        <xsl:choose>
  	        <xsl:when test="function-available('saxon:createJPEG')"> 
  	        <xsl:message><xsl:text>blah blah blah </xsl:text></xsl:message>
    	        <xsl:value-of 
    	        	select="saxon:createJPEG('hidden.jpg', 'independence', 
    	        		                       48, 200, 100)"/>
      	    </xsl:when>
        	  <xsl:when test="function-available('xalan:createJPEG')">
          	  <xsl:value-of 
          	  	select="xalan:createJPEG('hidden.jpg', 'flavor', 
          	  	                         48, 200, 100)"/>
	          </xsl:when>
	          <xsl:when test="function-available('dotnet:createJPEG')">
		          <xsl:value-of 
		          	select="dotnet:createJPEG('hidden.jpg', 'monkey', 
		          	                          48, 200, 100)"/>
		        </xsl:when>
  	        <xsl:otherwise>
  	        	<xsl:message terminate="yes">
  	        		<xsl:text>[No image function available]</xsl:text>
  	        	</xsl:message>
        	  </xsl:otherwise>
	        </xsl:choose>
        </xsl:variable>
        <form align="center">
          <p>Enter the word hidden in the graphic below</p>
          <xsl:choose>
            <xsl:when test="string-length($error)">
              <p>
                <xsl:value-of select="$error"/>
              </p>
            </xsl:when>
            <xsl:otherwise>
              <p>
                <img src="hidden.jpg" width="200" height="100" border="1"/>
              </p>
            </xsl:otherwise>
          </xsl:choose>
          <p>
            <input type="text" name="hiddenWord" size="20" maxlength="20"/>
          </p>
          <p>
            <input type="submit" value="Submit"/>
          </p>
        </form>
      </body>
    </html>
  </xsl:template>

</xsl:stylesheet>
