<?xml version="1.0"?>
<!-- saxon-jpeg-extension.xsl -->
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:saxon="java:com.oreilly.xslt.HiddenWord"
  xmlns:xalan="xalan://com.oreilly.xslt.HiddenWord"
  extension-element-prefixes="saxon xalan">

  <xsl:output method="html"/>

  <xsl:template match="/">
    <html>
      <head>
        <title>
          <xsl:value-of select="'Test of hidden word generator'"/>
        </title>
      </head>
      <body style="font-family: sans-serif;">
	      <h1>Test of hidden word generator</h1>
	      <table border="2" cellpadding="5">
	        <xsl:for-each select="/book/chapter">
		        <tr>
		        <td>
  		        <xsl:choose>
                <xsl:when test="function-available('xalan:createJPEG')">
                	<p>Xalan extension: 
		            		<xsl:value-of 
		            			select="xalan:createJPEG(concat('title', position(), '.jpg'),
		            			48, 200, 100)"/>
		            	</p>
            		  <img src="{concat('title', position(), '.jpg')}"/>
              		<br />
		            </xsl:when>
    		        <xsl:when test="function-available('saxon:createJPEG')"> 
	    		        <p>Saxon extension: 
  	    		        <xsl:value-of 
    	    		        select="saxon:createJPEG(concat('title', position(), '.jpg'), 
      	    		      48, 200, 100)"/>
      		 	      </p>
            		  <img src="{concat('title', position(), '.jpg')}"/>
              		<br />
		            </xsl:when>
	  	          <xsl:otherwise>	
  	  	          <h1><xsl:value-of select="title"/></h1>
  	  	          <p>No extension found</p>
    	  	      </xsl:otherwise>
      	  	  </xsl:choose>
    	  	  </td>
	   	  	  </tr>
	        </xsl:for-each>
        </table>
      </body>
    </html>
  </xsl:template>

</xsl:stylesheet>
